% Set of macros for making table of contents of a book

% This file is public domain.

\newwrite\contentsfile%
\immediate\openout\contentsfile=\jobname.toc %

\newcount\chapno%

\def\gobble#1{}%

\font\chaplfont=cmr10 scaled \magstep2 %
\font\chapnfont=cmbx10 scaled \magstep2 %

\def\sectionheading#1#2{%
  \vfil\eject%
  \hrule%
  \hbox to\hsize{%
    \vrule%
    \vbox to 24pt{%
      \vfil%
      \hbox{
        \kern18pt\chapnfont#1\chaplfont#2%
      }%
      \vfil%
    }%
    \hfil%
  }%
  \bigskip%
}%

\def\chapterheading#1{\sectionheading{\the\chapno. }{#1}}%

\def\unnchapterheading#1{\sectionheading{}{#1}}%

\def\chapter: #1. {%
  \advance\chapno by 1 %
  \chapterheading{#1}%
  \edef\next{\write\contentsfile{%
    \noexpand\noexpand\noexpand\chapterline%
    {#1}{\the\chapno}{\noexpand\the\pageno}%
  }}\next%
}%

\def\unnchapter: #1. {%
  \unnchapterheading{#1}%
  \edef\next{\write\contentsfile{%
    \noexpand\noexpand\noexpand\chapterline%
    {#1}{}{\noexpand\the\pageno}%
  }}\next%
}%

\def\chapterline#1#2#3{%
  \line{%
    \hbox to 48pt{\hfil\bf#2\quad}%
    \rm#1\kern6pt%
    \leaders\hbox{ . }\hfill%
    \kern6pt\rm#3\kern4pt%
  }%
}%

\def\TableOfContents{{%
  \par%
  \global\pageno=0 %
  \immediate\closeout\contentsfile%
  \parindent=0pt %
  \leftskip=14pt %
  \rightskip=0.15in %
  \parskip=0pt %
  \pageno=0 %
  \input\jobname.toc %
}}%
